﻿Type=Class
Version=2
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private basePanel As Panel
	Private ActivityIndicator1 As ActivityIndicator
	Private lblHoldToRecord As Label
	Private ar As AudioRecorder
	Private sessionId As String
	Private mEventName As String
	Private mTarget As Object
'	Private NewDate As String
	Private year As String
	Private day As String
	Private month As String
	Private newdate As String
	Private textview2 As TextView	
	Private Label99 As Label
End Sub
Public Sub Initialize (TargetModule As Object, EventName As String)
   ar.Initialize(File.DirTemp, "1.wav", 16000, True, 16, False)
   sessionId = Rnd(1000000, 9999999)
   mTarget = TargetModule
   mEventName = EventName
   Dim no As NativeObject = Me
   no.RunMethod("setAudioSession", Null)
   
End Sub

#If OBJC
#import <AVFoundation/AVFoundation.h>
#import <AudioToolbox/AudioToolbox.h>
- (void)setAudioSession {
 [[AVAudioSession sharedInstance]
  setCategory:AVAudioSessionCategoryPlayAndRecord
  withOptions:AVAudioSessionCategoryOptionDefaultToSpeaker error:nil];
}
#end if
public Sub AddToPanel(pnl As Panel)
	pnl.LoadLayout("SpeakButton")
End Sub
private Sub BasePanel_Touch(Action As Int, X As Float, Y As Float)
	If Action = basePanel.ACTION_DOWN Then
		ar.Record
		basePanel.Color = Colors.Green
		ActivityIndicator1.Visible = False
	else if Action = basePanel.ACTION_UP Then
		basePanel.Color = Colors.Transparent
		ActivityIndicator1.Visible = True
		lblHoldToRecord.Visible = False
		ar.Stop
		Dim j As HttpJob
		j.Initialize("j", Me)
		Dim jg As JSONGenerator
		jg.Initialize(CreateMap("v": "20150415", "lang": "en", "sessionId": sessionId))
		Dim fd As MultipartFileData
		fd.ContentType = "audio/wav"
		fd.Dir = File.DirTemp
		fd.FileName = "1.wav"
		fd.KeyName = "voiceData" '+"@sys.date"
		j.PostMultipart("https://api.api.ai/v1/query", CreateMap("request":jg.ToString), Array(fd))
		j.GetRequest.SetHeader("Authorization", $"Bearer ${Main.CLIENT_TOKEN}"$)
		j.GetRequest.SetHeader("ocp-apim-subscription-key", Main.SUBSCRIPTION_KEY)
	End If	
End Sub
Sub JobDone(job As HttpJob)
	ActivityIndicator1.Visible = False
	lblHoldToRecord.Visible = True
	If job.Success Then
		Dim jp As JSONParser
		jp.Initialize(job.GetString)
		Log(job.GetString)
		Dim result As Map = jp.NextObject.Get("result")
		Dim resolvedQuery As String = result.Get("resolvedQuery")
		Dim Parser As JSONParser
		Dim JSONMap As Map
		Parser.Initialize(job.GetString)
		JSONMap = Parser.NextObject
		JSONMap = JSONMap.Get("result")
		'Msgbox ("result=" & result,"")
		JSONMap = JSONMap.Get("parameters")
		Dim date As String = JSONMap.Get("date")
		Dim adata() As String
		adata = Regex.Split("-",date)
		'Dim adata() As String
		'adata = Regex.split("-",date): 
		year = adata(0): month = adata(1): day=adata(2)
		newdate = month & "/" & day & "/" & year
'		lblHoldToRecord.Text = lblHoldToRecord.Text & "(" & newdate & ")"
		'Msgbox ("NewDate=" & NewDate,"")
		'ourdate = date
'		textview2.text = "Date Values:" & newdate		
		Label99.Text = "Date Values:" & newdate		
		CallSub3(mTarget, mEventName & "_result", True, resolvedQuery)
		Else
		CallSub3(mTarget, mEventName & "_result", False, job.ErrorMessage)
	End If
	job.Release
End Sub









